#open "item";;
#open "bag";;

(* Why is not this written in fuzz *)

(* Bag functions implementations *)

(* bagsize : 'a bag -o Num *)
let bagsize = IFn (fun x -> match x with
    IBag xs -> INum (float_of_int (list_length xs))
  | _ -> raise (Failure "runtime type error: bagsizing a nonbag")
);;

(* bagsum : (clip num) bag -o Num *)
let bagsum = IFn (fun x -> match x with
    IBag xs -> let rec isum x = match x with
	[] -> 0.0
      | (INum x::tl) -> x +. isum tl
      | _ -> raise (Failure "runtime type error: bagsum adding nonnumber")
	       in INum (isum xs)
  | _ -> raise (Failure "runtime type error: bagsumming a nonbag")
);;


(* bagmap : ('a -> 'b) -> num -> 'a bag -o 'b bag  *)
let bagmap = IFn (fun f -> ( IFn (fun limit -> IFn (fun bag ->
  let rec bmap f1 b1 =  (match b1 with
      [] ->  []
    | x::xs ->  ((iapp f1 x) :: (bmap f1 xs))
  )
  in
  (match bag with
      IBag bs -> IBag (bmap f bs)
    | _ -> raise (Failure "runtime error: bagmapping nonbag")
  )
))));;

(* bagsplit : ('a -> bool) -> num -> 'a bag -o 'a bag * 'a bag *)

(* Note: bagsplit can be derived using other fuzz functions unless the
   timeouts are needed. Here we define it as primitive only for
   coherence with the timeout version.
*)

let rec length l = match l with
    [] -> 0
  | x::xs -> (length xs)+1;;

let rec split = fun f1 -> fun b1 ->
    (match b1 with
	[] -> ([],[])
      | x::xs ->
	(match iapp f1 x with
	    IBool b -> let y= (split f1 xs) in (if b then (x::(fst y), (snd y)) else  ((fst y), x::(snd y)))
	  |_ -> raise (Failure "runtime error: split test nonbool")
    ));;

let bagsplit = IFn (fun f -> IFn (fun timeout -> IFn (fun bag ->
  (match bag with
      IBag bs -> (match (split f bs) with b1, b2 -> IPair ((IBag  b1 ),(IBag b2)))
    | _ -> raise (Failure "runtime error: bagsplitting nonbag")
  )
)));;


(***************************************************************************)
(* Protected stuff *)

(* Should use IMemoryBag *)
(* Microquery inner loop *)

(* let int_of_string = (fun x -> int_of_float (float_of_string x));; *)

(*let mq f timeout =
    (fun x -> let row = string_to_item x in
		  item_to_string (iapp f row)
    );;
*)

(* let mq f timeout numDBexpected defaultVal = *)
(*   (fun x -> ( *)
(*      let _ = pre_mqs x numDBexpected defaultVal in *)
(*      let r = checkpoint timeout in *)
(*      match (nth_char r 0) with *)
(*        `1` -> (IBag (int_of_string(sub_string r 1 ((string_length r)-1)))) *)
(*      | `2` -> (IPair ((IBag (int_of_string(sub_string r 1 ((index_char r `,`)-1)))), *)
(*                       (IBag (int_of_string(sub_string r ((index_char r `,`)+1) ((string_length r)-(index_char r `,`)-1)))) *)
(*               )) *)
(*      |  _  -> let row = string_to_item r in *)
(* 	        let result = item_to_string (iapp f row) in *)
(* 		   let _ = store_result(result) in *)
(*                      (IBag 0) (\* Just to typecheck, will never be run*\) *)
(*   ));; *)

(* (\* bagmap : ('a -> 'b) -> 'a -> Num -> 'a bag -> 'b bag  *\) *)
(* let bagmap = IFn (fun f -> IFn (fun default -> IFn (fun t -> IFn (fun bag -> *)
(*   let timeout = (int_of_float (float_of_item t)) in *)
(*     let xs = match bag with *)
(*       IBag xs -> xs *)
(*     | _       -> raiseAndPrint (Failure "runtime error: bagmapping nonbag") in *)
(*          mq f timeout 1 (item_to_string default) xs))));; *)

(* (\* bagsplit : ('a -> bool) -> Num -> 'a bag -> 'a bag * 'a bag *\) *)
(* let bagsplit = IFn (fun f -> IFn (fun t -> IFn (fun bag -> *)
(*   let timeout = (int_of_float (float_of_item t)) in *)
(*     let xs = match bag with *)
(*       IBag xs -> xs *)
(*     | _       -> raiseAndPrint (Failure "runtime error: bagmapping nonbag") in *)
(*          mq f timeout 2 "F;" xs)));; *)

(* let bagsize = IFn (fun x -> match x with IBag xs -> INum (cbagsize xs) | _ -> raiseAndPrint (Failure "runtime type error: bagsizing a nonbag"));; *)


(* let bagsum = IFn (fun x -> match x with IBag xs -> INum (cbagsum xs) | _ -> raiseAndPrint (Failure "runtime type error: bagsumming a nonbag"));; *)
