type item = INum of float
            | IPair of item * item
            | IUnit
            | IInl of item
            | IInr of item
            | IFn of item -> item
            | IFuzz of unit -> item
            | IBag of item list
	    | IMemoryBag of int
	    | IFinMap of (item * item) list
            | IBool of bool
            | IString of string;;

(* Applicaction *)
value iapp : item -> item -> item;;

value iequal : item -> item -> item;;
value igt : item -> item -> item;;
value ilt : item -> item -> item;;
value iconj : item -> item -> item;;
value idisj : item -> item -> item;;
value iplus : item -> item -> item;;
value iminus : item -> item -> item;;
value idiv : item -> item -> item;;
value imult : item -> item -> item;;

value icswp : item -> item;;

(* Weird constructions *)
value decons_pair : item -> item * item;;
value fuzz_of_item : item -> unit -> item;;

(* Tests if true *)
value itrue : item -> bool;;

(* Monad *)
value return : item;;
value sample : (item -> item) -> item -> item;;


(* Util *)
value num2string : item;;
value item_to_string : item -> string;;

value clip : item;;
value fuzz : float -> item;;
