(* Old primitives *)

(*expfuzz : R bag -> (A bag x R -o num) -> A bag -o fuzzy R *)
let expfuzz = IFn (fun range -> IFn (fun quality -> IFn (fun data ->
  let rec exp_dist range1 quality1 data1 = match range1 with
      [] -> []
    | x::xs -> match (iapp quality1 (IPair (data1,x))) with
	INum  d -> (exp(0.1 *. 0.5 *. d)) :: (exp_dist xs quality1 data1)
	| _ -> raise (Failure "runtime error: expfuzz nonnum")
  in  (match range  with
      IBag brange -> (
(*match data with IBag bdata -> *)
	let list_prob = exp_dist brange quality data in
	let sum_prob = (it_list (fun x -> fun y -> x +. y) 0.0 list_prob) in
	let pr_index = random__float(sum_prob) in
	    let rec select_item pr list_items =
	      if (pr <= 0.0)
	      then
		((hd list_items))
	      else
		(select_item (pr -. hd(list_items)) (tl list_items))
	    in
	    (IFuzz (fun () -> INum (select_item pr_index list_prob))))

    | _ -> raise (Failure "runtime error: expfuzz nonbag")
  )
)));;



(* Additional primitives for IDC 
let clipped_mult = IFn (fun x -> fun y -> match x with
    INum x -> match y with
        INum y -> x *. y
      | _ -> raise (Failure "runtime type error: second parameter to clipped_mult is not number")
  | _ -> raise (Failure "runtime type error: first parameter to clipped_mult is not number")
);;

let exp_num = IFn (fun x -> match x with
    INum x -> INum (exp x)
  | _ -> raise (Failure "runtime type error: taking exponential of a nonnumber")
);;

let abs_num = IFn (fun x -> match x with
    INum x -> INum (abs_float x)
  | _ -> raise (Failure "runtime type error: taking absolute value of a nonnumber")
);;
*)
(*expfuzz : R bag -> (A bag x R -o num) -> A bag -o fuzzy R *)
(*expfuzz_fix : R bag -> (R -> A bag -o num) -> A bag -o fuzzy R *)
let expfuzz_fix = IFn (fun range -> IFn (fun quality -> IFn (fun data ->
  let rec exp_dist range1 quality1 data1 = match range1 with
      [] -> []
    | x::xs -> match (iapp (iapp quality1 x) data1) with
	INum  d -> (exp(0.1 *. 0.5 *. d)) :: (exp_dist xs quality1 data1)
	| _ -> raise (Failure "runtime error: expfuzz_fix nonnum")
  in  (match range  with
      IBag brange -> (
(*match data with IBag bdata -> *)
	let list_prob = exp_dist brange quality data in
	let sum_prob = (it_list (fun x -> fun y -> x +. y) 0.0 list_prob) in
	let pr_index = random__float(sum_prob) in
	    let rec select_item pr list_items =
	      if (pr <= 0.0)
	      then
		((hd list_items))
	      else
		(select_item (pr -. hd(list_items)) (tl list_items))
	    in
	    (IFuzz (fun () -> INum (select_item pr_index list_prob))))

    | _ -> raise (Failure "runtime error: expfuzz_fix nonbag")
  )
)));;

