#include <stdio.h>
#include <string.h>
#include <config.h>
#include <alloc.h>
#include <memory.h>
#include <misc.h>
#include <mlvalues.h>
#include "pcre.h"

// Some stubs for the pcre regex library at pcre.org

#define OVECSIZE 30 

const char *error;
int erroroffset;
int ovector[OVECSIZE];

value stub_pcre_compile(value patstr) {
  return (value) pcre_compile (String_val(patstr), 0, &error, &erroroffset, NULL);
}

value stub_pcre_match(value pat, value str) {
  char *s = String_val(str);
  int n = strlen(s);
  return Val_int (pcre_exec((pcre *) pat, NULL, s, n, 0, 0, ovector, 30));
}

value stub_pcre_ovector(value n) {
  int i = Int_val(n);
  if (i < 0) i = 0;
  if (i >= OVECSIZE) i = 0;
  return Val_int (ovector[i]);
}
