open Support
open Syntax

(* A sensitivity constraint *)

(* XXX: The z3 pretty printing needs this, so we either we define a
   structural fold for si constraints or use the private keyword *)
type si_cstr = private
  CSiEq of FileInfo.info * si * si
| CSiGe of FileInfo.info * si * si

(* A constraint store *)

(* XXX: Not good, not good, make this abstract, the same problem than
   before occurs in the z3py pretty printing

   This is easier to solve as we'd only need an Constraint.iter_cs
*)
type c_store = si_cstr list

val empty_cs : c_store

val cs_eq : FileInfo.info -> si -> si -> si_cstr
val cs_ge : FileInfo.info -> si -> si -> si_cstr

val post_cs : c_store -> si_cstr -> c_store option

(* Helpers for debug *)
val clean_simpl : c_store -> c_store * c_store

val simpl_subst : c_store -> c_store

(* Pretty printing exports *)
val pp_si_cstr_elem    : Format.formatter -> si_cstr -> unit
val pp_si_cstr_elem_fi : Format.formatter -> si_cstr -> unit

val pp_cs_dirty        : Format.formatter -> c_store -> unit
val pp_si_store        : Format.formatter -> c_store -> unit
