open Syntax

(* Contexts of type 'a *)
type 'a ctx = (var_info * 'a) list

type context =
    {
      var_ctx   : (si option * ty) ctx;
      tyvar_ctx : kind ctx;
    }

val empty_context : context

val ctx_ty_subst : context -> (ty -> ty) -> context

val ctx_efv      : context -> VarSet.t

val extend_var   : string -> (si option * ty) -> context -> context
val extend_tyvar : string -> kind -> context -> context

val remove_first_var : context -> context

val access_var   : context -> int -> var_info * (si option * ty)
(* let access_ty_var ctx i = List.nth ctx.tyvar_ctx (i-1) *)

(* Name based functions for the parser *)
val lookup_var   : string -> context -> (var_info * (si option * ty)) option
val lookup_tyvar : string -> context -> (var_info * kind) option


